<?php
/**
*
*  @author BAKO AI
*  @copyright  2018 BakoAi
*
*/

/**
 * @since 1.5.0
 */
class AirtelMoneyPaymentModuleFrontController extends ModuleFrontController
{
    private $tampon = array();

    public function postProcess(){
        Parent::postProcess();
        $cart = $this->context->cart;
        $customer = new Customer($cart->id_customer);

        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'airtelmoney') {
                $authorized = true;
                break;
            }
        }

        if (!$authorized) {
            //die($this->trans('This payment method is not available.', array(), 'Modules.Checkpayment.Shop'));
            die('This payment method is not available');
        }

        $customer = new Customer($cart->id_customer);

        if (!Validate::isLoadedObject($customer)) {
            Tools::redirect('index.php?controller=order&step=1');
        }
        $currency = $this->context->currency;
        $total = (float)$cart->getOrderTotal(true, Cart::BOTH);

        $mailVars =  array();

        $this->module->validateOrder((int)$cart->id, Configuration::get('PS_OS_BANKWIRE'), $total, $this->module->displayName, null, $mailVars, (int)$currency->id, false, $customer->secure_key);
        sleep(3);

        $r = Order::getByCartId($cart->id)->getUniqReference();
        $this->tampon =  array("tel_marchand"=>Configuration::get('AIRTELMONEY_MERCHANT_PHONE'),
            "montant"=> $total,
            "ref"=> Configuration::get("AIRTELMONEY_REF_PREFIX").'-'.$r,
            "redirect" =>Tools::getValue("redirect"),
            "urlPvitApi"=>"https://mypvit.com/airtelmoneypvit.kk",
            "logo"=>Media::getMediaPath(_PS_MODULE_DIR_.'/airtelmoney/airtel-money.png')
        );
    }

    public function initContent()
    {
        parent::initContent();

        $this->setTemplate("module:airtelmoney/views/templates/front/form_post_4.tpl");

        $this->context->smarty->assign($this->tampon);
    }


}
